#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}function changes(){return transmute__default({}).extend("rawTags",gatherTags).extend("tags",parseTags).extend("latest",latestReleaseTag).extend("from",({latest:e})=>e.tag).extend("changes",gatherChanges)}function list(e){return transmute__default({}).extend("root",findRepoRoot).extend("rootStructure",getRootStructure).extend("rootManifest",getRootManifest).extend("exclude",["**/fixtures/**"]).extend("packageNames",filterPackages(e)).extend("structures",getStructures).extend("types",getTypes(e)).extend("manifests",getPackageDetails(e))}function dependencies(e){return list(e).extend("dependencies",getDependencies(e))}function version(e){return list(_extends({},e,{changedAndPublishable:!0})).extend(changes(e).then(transmute.isolate(["changes","latest"]))).extend("dependencies",dependencies(e).then(transmute.isolate("dependencies"))).extend("updates",recommendVersions)}function check(e){return list(e).extend("checks",publishCheck(e))}function prerelease(e){return check(e).extend("unpublishable",({packageNames:e,checks:t})=>e.filter(e=>!t.packages[e].publishable)).extend("name",({unpublishable:e})=>pickPackage({message:"Which package should we prerelease?",packageNames:e})).extend("structure",({name:e})=>getStructures({packageNames:[e]})[e]).extend("type",({name:t,structure:r})=>getTypes(e)({packageNames:[t],structures:{[t]:r}})[t]).extend(fixPackages(e))}var keyBy=_interopDefault(require("lodash.keyby")),every=_interopDefault(require("lodash.every")),chalk=require("chalk"),TS=_interopDefault(require("trie-search")),parse=_interopDefault(require("minimist")),RenderKid=_interopDefault(require("renderkid")),transmute=require("transmutation"),transmute__default=_interopDefault(transmute),toCamelCase=_interopDefault(require("to-camel-case")),prettyjson=require("prettyjson");require("loud-rejection/register");var configureGit=_interopDefault(require("simple-git/promise")),path=require("path"),findUp=_interopDefault(require("find-up")),semver=require("semver"),fs=require("fs"),fs__default=_interopDefault(fs),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),has=_interopDefault(require("lodash.has")),partial=_interopDefault(require("lodash.partial")),uniq=_interopDefault(require("lodash.uniq")),detective=_interopDefault(require("detective-es6")),frontMatter=_interopDefault(require("front-matter")),fileExists=require("file-exists"),execa=_interopDefault(require("execa")),map=_interopDefault(require("lodash.map")),jsonFile=_interopDefault(require("jsonfile")),editor=_interopDefault(require("edit-json-file")),filter=_interopDefault(require("lodash.filter")),intersect=_interopDefault(require("lodash.intersection")),fuzzy=require("fuzzy"),inquirer=_interopDefault(require("inquirer")),autocomplete=_interopDefault(require("inquirer-autocomplete-prompt")),sanitizer=e=>{if(!Array.isArray(e))throw new Error("Commands must be an array");if(e.length<=0)throw new Error("No commands defined");if(!every(e,e=>"function"==typeof e.run))throw new Error("All commands must have a run method");if(!every(e,e=>"name"in e))throw new Error("Not every command has a name")},asyncToGenerator=function(e){return function(){var t=e.apply(this,arguments);return new Promise(function(e,r){function n(a,s){try{var i=t[a](s),o=i.value}catch(e){return void r(e)}if(!i.done)return Promise.resolve(o).then(function(e){n("next",e)},function(e){n("throw",e)});e(o)}return n("next")})}},_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},toArray=function(e){return Array.isArray(e)?e:Array.from(e)},createSearcher=({commands:e=[]}={})=>{const t=e.map(e=>{const t=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...t].join(" ")})}),r=new TS(["tokens"]);return r.addAll(t),r},createDecider=({proposedDefault:e,commands:t})=>{const r=Object.values(t),n=1===r.length?r[0]:null,a=("string"==typeof e?t[e]:e)||n,s=createSearcher({commands:r});return e=>{if(!e)return a;const t=s.get(e);return t.length>0?t[0]:a||(console.log(chalk.red(`No command associated with \`${e}\``)),process.exit(127))}},cleanser=e=>t=>Object.entries(t).map(([t,r])=>t in e?{[t]:e[t](r)}:{[t]:r}).reduce((e,t)=>_extends({},e,t),{}),convertArgs=({args:e={},conversions:t={}})=>Object.entries(e).map(([e,t])=>["_"!==e?toCamelCase(e):e,t]).map(([e,r])=>e in t?[t[e],r]:[e,r]).reduce((e,t)=>_extends({},e,{[t[0]]:t[1]}),{});const jsonRender=e=>t=>r=>e(prettyjson.render(transmute.isolate(t)(r)));var createExecutor=({config:e,cleanse:t,defaultRenderer:r,defaultStyle:n,decider:a}={})=>(s=[""])=>{const i=parse(s,{boolean:!0});var o=toArray(i._);const c=o[0],l=o.slice(1),u=i.commit,d=i.json,p=i.dry,m=a(c),g=_extends({},i,{_:l}),h=convertArgs({args:g,conversions:m.args}),f=cleanser(t)(_extends({},e,h)),y=new RenderKid;y.style(n);const k=m.template?e=>y.render(m.template(f)(e)):e=>e,b=m.effect?e=>m.effect(f)(e):e=>e,v=Promise.resolve(m.run(f)),x=m.renderer||r;if(d){const e=jsonRender(x);return v.then(e(!0===d||d.split(",")))}return v.then(e=>{x(k(e)),(u||m.autoCommit&&!p)&&b(e)})};const configureKli=({defaultStyle:e={},defaultRenderer:t=console.log}={})=>({default:r,config:n={},commands:a=[],cleanse:s={}}={})=>{sanitizer(a);const i=keyBy(a,"name"),o=createDecider({commands:i,proposedDefault:r});return{execute:createExecutor({config:n,defaultStyle:e,defaultRenderer:t,decider:o,cleanse:s})}},configure=configureKli,kli$1=configureKli();configureKli();var style={title:{display:"block",color:"bright-white",marginLeft:2,marginBottom:1},check:{display:"block",marginLeft:4},details:{color:"grey",marginLeft:4},success:{display:"block",color:"grey",bullet:`"${chalk.green("✔")} "`},fail:{display:"block",color:"red",bullet:`"${chalk.red("✖")} "`},warning:{display:"block",color:"bright-yellow",bullet:`"${chalk.yellow("⚠")} "`},list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},bullet:{display:"block",marginLeft:2},change:{display:"block"},type:{color:"white"},scope:{color:"bright-white"},subject:{color:"grey"},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green",bullet:`"${chalk.green("────────────────────────────────────────────────────────────────────────────────")}"`},h1:{display:"block",color:"bright-white",marginLeft:2}};const regex=/#(\d*)/;var parseTags=({rawTags:e=[]}={})=>e.map(e=>e.match(regex)||[]).filter(e=>e.length).map(([e,t])=>({tag:e,releaseNumber:parseInt(t,10)}));const git=configureGit();var gatherTags=()=>git.tags().then(({all:e})=>e),template=()=>({changes:e})=>`\n    <bar>-</bar>\n    <h1>Changes</h1>\n    <bar>-</bar>\n    <list>\n        ${e.sort(()=>1).map(({type:e,scopes:t,subject:r})=>`\n                    <change>\n                        <type>${e}</type>\n                        <scope>(${t.join(",")})<scope>: \n                        <subject>${r}</subject>\n                    </change>\n                `).join("")}\n    </list>\n`;const regex$1=/^([^A-Z]*)\(((?:[^A-Z*]*)|\*)\): ([^a-z].*\.)$/,toHeaderOrBody=({body:e,matches:[,t,r,n]})=>t?{type:t,scopes:r.split(",").map(e=>e.trim()),subject:n}:{body:e},intoSingleCommits=(e,t)=>{if(0===e.length)return[t];var r=e.reverse(),n=toArray(r);const a=n[0],s=n.slice(1);return"body"in a&&"body"in t?[...s,_extends({},a,{body:[a.body,t.body].join("\n")})]:t.type?[...e,t]:[...s,_extends({},a,t)]},trimmedBodies=e=>e.body?_extends({},e,{body:e.body.trim()}):e;var parse$1=({commits:e=[]}={})=>Array.prototype.concat(...e.map(({hash:e,message:t,files:r})=>t.split(/\r?\n/).map(e=>({body:e,matches:e.match(regex$1)||[]})).map(toHeaderOrBody).reduce(intoSingleCommits,[]).map(trimmedBodies).map(t=>_extends({hash:e,files:r},t))));const git$1=configureGit();var gatherChanges=({from:e,to:t="HEAD"}={})=>git$1.log({from:e,to:t,format:{hash:"%H",message:"%B"}}).then(({all:e})=>Promise.all(e.map(e=>git$1.show(["--pretty=","--name-only",e.hash]).then(e=>e.trim().split("\n")).then(t=>_extends({},e,{files:t}))))).then(e=>({commits:e})).then(parse$1),latestReleaseTag=({tags:e=[]}={})=>e.filter(e=>e.releaseNumber).reduce((e,t)=>e.releaseNumber>t.releaseNumber?e:t,{tag:"HEAD",releaseNumber:0});const command=()=>({name:"changes",aliases:["changelog"],run:changes,template:template});var git$2=configureGit().outputHandler((e,t,r)=>{t.pipe(process.stdout),r.pipe(process.stderr)}),setupGit=()=>{var e=process.env;const t=e.GH_USER,r=e.GH_EMAIL,n=e.GH_REPO,a=e.GH_TOKEN;return console.log("Setting committer..."),git$2.addConfig("user.name",t).then(()=>git$2.addConfig("user.email",r)).then(()=>console.log("Setting up branch...")).then(()=>git$2.addRemote("origin-deploy",`https://${a}@github.com/${n}.git`)).then(()=>git$2.fetch("origin-deploy","master")).then(()=>git$2.checkout(["-B","deploy-master","--track","origin-deploy/master"])).then(()=>git$2.reset(["--hard","origin-deploy/master"]))},deployGit=()=>(console.log("Pushing to deploy remote..."),git$2.push(["origin-deploy","HEAD:master","--tags"])),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname),getRootManifest=({root:e="."}={})=>require(path.resolve(e,"package.json")),getPublishing=({destination:e={}}={})=>Object.entries(e).filter(([,{destVersion:e,srcVersion:t}])=>!!semver.valid(t)&&(!semver.valid(e)||semver.gt(t,e))).map(([e])=>e);const glob=promisify(unglob),lstat=promisify(fs__default.lstat),have=e=>t=>match(e,t);var findPackages=({root:e=".",exclude:t=[]}={})=>new Promise((()=>{var r=asyncToGenerator(function*(r,n){try{const a=path.resolve(e,"src/node_modules");if(!(yield lstat(a)).isDirectory)return n("The `src/node_modules` directory does not exist!");const s=path.resolve(a,"{[^@]*/,@*/*/}");return r((yield glob(s)).filter(function(e){return!t.some(have(e))}).map(function(t){return path.relative(path.resolve(e,"src/node_modules"),t)}))}catch(e){return n(e)}});return function(e,t){return r.apply(this,arguments)}})()),collapsePackages=(e,t)=>{if(t.undefined){const r=e.undefined?[...e.undefined,t.undefined]:[t.undefined];return _extends({},e,{undefined:r})}return Object.assign(e,t)};const requiredProps=["description","homepage","author","repository","bugs","license","dependencies"],isIn=e=>partial(has,e);var publishCheck=({plugins:e={}}={})=>({rootStructure:{files:t=[]}={},rootManifest:r={},packageNames:n=[],types:a={},structures:s={},manifests:i={}}={})=>Promise.all(n.map(t=>{const r={[t]:{}};return e[a[t]]&&e[a[t]].check?e[a[t]].check({structure:s[t],manifest:i[t]}).then(e=>({[t]:e})):r})).then(e=>e.reduce(collapsePackages,{})).then(e=>({root:{"has root license":t.includes("LICENSE"),"has required props":every(requiredProps,isIn(r))},packages:e})),parseSfp=({content:e=""}={})=>{var t=frontMatter(e);const r=t.attributes,n=t.body;return{body:n.trim(),attributes:r,code:n.split("\n").reduce(({inBlock:e,bundle:t},r)=>"```"===r.slice(0,3)?{inBlock:!e,bundle:t}:e?{inBlock:e,bundle:t?`${t}\n${r}`:r}:{inBlock:e,bundle:t},{inBlock:!1,bundle:""}).bundle}};const readFile=promisify(fs__default.readFile),cache={};var detective$1=({root:e,locals:t=[],structures:r={},manifests:n={}})=>(()=>{function a(e){return s.apply(this,arguments)}var s=asyncToGenerator(function*(s){if(!s)return{};var i=n[s]||{};const o=i.main,c=i.bin;var l=r[s]||{};const u=l.srcDir,d=l.files,p=o||(c?Object.values(c)[0]:d.includes("index.md")?"index.md":"index.js");return fileExists.sync(path.resolve(e,u,p))?readFile(path.resolve(e,u,p),"utf-8").then(function(e){return".md"===path.extname(p)?parseSfp({content:e}).code:e}).then(detective).then(function(e){return Promise.all(e.map((()=>{var e=asyncToGenerator(function*(e){return t.includes(e)?e in cache?cache[e]:a(e).then(function(t){return 0===Object.keys(t).length&&t.constructor===Object?{[e]:!1}:{[e]:t}}).then(function(t){return cache[e]=t,t}):{[e]:!1}});return function(t){return e.apply(this,arguments)}})())).then(function(e){return e.reduce(collapsePackages,{})})}):{}});return a})();const cache$1={},getStructure=({root:e,name:t})=>{if(t in cache$1)return{[t]:cache$1[t]};const r=path.relative(e,path.resolve(e,"src/node_modules",t)),n={name:t,root:e,srcDir:r,destDir:path.relative(e,path.resolve(e,"dist",t)),files:fs.readdirSync(path.resolve(e,r))};return cache$1[n.name]=n,{[t]:n}};var getStructures=({root:e,packageNames:t=[]})=>t.map(t=>getStructure({root:e,name:t})).reduce(collapsePackages,{}),getPackageDetails=({plugins:e})=>({root:t=".",packageNames:r=[],types:n={},structures:a={}})=>Promise.all(r.map((()=>{var r=asyncToGenerator(function*(r){return"unknown"!==n[r]?{[r]:(yield e[n[r]].manifest({root:t,structure:a[r],name:r}))||{}}:{[r]:{}}});return function(e){return r.apply(this,arguments)}})())).then(e=>e.reduce(collapsePackages,{})),getTypes=({plugins:e={}})=>({packageNames:t=[],structures:r={}})=>t.map(t=>[t,Object.values(e).find(({filter:e})=>e(r[t]))]).map(([e,{type:t="unknown"}={}])=>({[e]:t})).reduce(collapsePackages,{}),getDependencies=e=>(()=>{var t=asyncToGenerator(function*({root:t,exclude:r,packageNames:n=[]}={}){if(!t)return{};if(n.length<=0)return{};var a=yield transmute__default({root:t,exclude:r}).extend("packageNames",findPackages).extend("structures",getStructures).extend("types",getTypes(e)).extend("manifests",getPackageDetails(e));const s=a.packageNames,i=a.structures,o=a.manifests,c=detective$1({root:t,locals:s,structures:i,manifests:o});return Promise.all(n.map(function(e){return c(e).then(function(e){return Object.entries(e).reduce(function e(t,[r,n]){return[...t,r,...Object.entries(n).reduce(e,[])]},[])}).then(uniq).then(function(t){return{[e]:{local:t.filter(function(e){return s.includes(e)}),external:t.filter(function(e){return!s.includes(e)})}}})})).then(function(e){return e.reduce(collapsePackages,{})})});return function(){return t.apply(this,arguments)}})();const fields=["version"];var destinationDetails=({root:e,packageNames:t,structures:r})=>Promise.all(t.map(t=>Promise.all([execa("npm",["view",t,...fields]).then(e=>e.stdout).catch(()=>null),new Promise(n=>{try{const a=path.resolve(e,r[t].srcDir,"package.json");return n(require(a).version)}catch(e){throw e}}).catch(()=>null)]).then(([e,r])=>({[t]:{destVersion:e,srcVersion:r}})))).then(e=>e.reduce(collapsePackages,{})),filterPackages=e=>t=>{const r=e.packageNames,n=e.allPackages,a=e.onlyPublishable,s=e.onlyChanged,i=e.changedAndPublishable,o=e.needsPublishing;if(n)return findPackages(t);if(Array.isArray(r)&&r.length>0)return r;if(!(o||i||a||s))return findPackages(t);const c=transmute__default(t).extend("packageNames",findPackages).extend("structures",getStructures).extend("types",getTypes(e)).extend("manifests",getPackageDetails(e));if(o)return c.extend("checks",publishCheck(e)).extend("publishable",({packageNames:e,checks:t})=>e.filter(e=>t.packages[e].publishable)).extend("destination",e=>destinationDetails(_extends({},e,{packages:e.publishable}))).extend("publishing",getPublishing).then(({publishing:e})=>e);if(a)return c.extend("checks",publishCheck(e)).then(({packageNames:e,checks:t})=>e.filter(e=>t.packages[e].publishable));const l=c.extend(changes).extend("dependencies",getDependencies(e)).extend("changed",({packageNames:e,dependencies:t,changes:r})=>e.filter(e=>r.some(({scopes:r=[]})=>r.includes(e)||r.some(r=>t[e].local.includes(r)))));return i?l.extend("checks",publishCheck(e)).then(({changed:e,checks:t})=>e.filter(e=>t.packages[e].publishable)):s?l.then(({changed:e})=>e):findPackages(t)},getRootStructure=({root:e})=>({files:fs.readdirSync(e)});const readFile$1=jsonFile.readFile,writeFile=jsonFile.writeFile,writeFileSync=jsonFile.writeFileSync,read=promisify(readFile$1),writeJson=promisify(writeFile),write=(e,t)=>writeJson(e,t,{spaces:4}),git$3=configureGit();var updatePackages=({root:e,updates:t,packageNames:r=[],structures:n={},latest:a})=>{const s=a.releaseNumber+1;return console.log(`Starting release #${s}`),console.log("Updating package.json files..."),Promise.all(r.filter(e=>e in t).map(r=>{const a=(n[r]||{}).srcDir,s=path.resolve(e,a,"package.json");return read(s).then(e=>_extends({},e,{version:t[r].new})).then(e=>write(s,e)).then(()=>({name:r,version:t[r].new,file:s}))})).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Staging files for commit..."),yield git$3.add(map(e,"file")),e});return function(t){return e.apply(this,arguments)}})()).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Committing updates..."),yield git$3.commit(`release(${s}): Update package versions for ${e.length>1?`${e.length} packages.`:"1 package."}\n        \n${e.map(function({name:e,version:t}){return`v${t} ${e}`}).join("\n")}\n\n[skip ci]\n`),e});return function(t){return e.apply(this,arguments)}})()).then(e=>(console.log("Tagging commit with package versions..."),Promise.all(e.map(({name:e,version:t})=>git$3.addTag(`${e}-v${t}`))))).then(()=>(console.log("Tagging commit with new latest release tag..."),git$3.addTag(`#${s}`)))},template$3=()=>({updates:e})=>`\n    <bar>-</bar>\n    <h1>Packages to be updated</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e).map(([e,{old:t,new:r,type:n,reason:a}])=>`\n                    <item>\n                        <title>${e} - ${n}</title>\n                        <check>${a}</check>\n                        <check>${t} -> ${r}</check>\n                    </item>\n                `).join("")}\n    </list>\n    `;const createPatch=({name:e,version:t,reason:r})=>({[e]:{type:"patch",old:t,new:semver.inc(t,"patch"),reason:r}});var recommendVersions=({packageNames:e=[],dependencies:t={},manifests:r={},changes:n=[]}={})=>e.length<=0?{}:e.map(e=>{const a=(r[e]||{}).version;if(a){if("0.0.0"===a)return{[e]:{type:"patch",old:a,new:"0.0.1",reason:"Prereleased"}};if(semver.lt(a,"0.1.0")){const r=filter(n,t=>!!t.scopes&&t.scopes.includes(e));if(r.length>0)return createPatch({name:e,version:a,reason:`This had ${1===r.length?"1 change":`${r.length} changes`} while in development.`});if(!t[e])return;const s=filter(n,r=>!!r.scopes&&intersect(t[e].local,r.scopes).length>0);if(s.length>0)return createPatch({name:e,version:a,reason:`There ${1===s.length?"was 1 change":`were ${s.length} changes`} in dependencies while in development.`})}else;}}).filter(e=>e).reduce(collapsePackages,{});const CI$1=process.env.CI,command$1=()=>({name:"version",aliases:["update"],run:version,template:template$3,effect:()=>e=>{if(!CI$1)throw new Error("Committing new versions should only happen in CI.");return setupGit().then(()=>updatePackages(e)).then(()=>deployGit())}}),writeFile$1=promisify(fs__default.writeFile),fixers={"has readme file":({root:e,structure:{srcDir:t},contents:r})=>(console.log("Creating [readme.md]..."),writeFile$1(path.resolve(e,t,"readme.md"),r)),"has a version number":({root:e,structure:{srcDir:t},version:r})=>(console.log("Creating [package.json]..."),write(path.resolve(e,t,"package.json"),{version:r}))};var effect=()=>({root:e,structure:t,fixes:r})=>Promise.all(Object.entries(r).map(([r,n])=>fixers[r](_extends({root:e,structure:t},n))));const templates={"has readme file":"A readme will be created.","has a version number":"A version will be added."};var template$4=()=>({name:e,fixes:t})=>`\n    <bar>-</bar>\n    <h1>Prereleasing [${e}]</h1>\n    <bar>-</bar>\n    <list>\n    ${Object.entries(t).map(([e])=>`<check><success>${templates[e]}</success></check>`).join("")}\n    </list>\n`;inquirer.registerPrompt("autocomplete",autocomplete);const searchPackages=e=>(t,r="")=>new Promise(t=>{setTimeout(()=>t(fuzzy.filter(r,e).map(e=>e.original||e)),500)});var pickPackage=({message:e="Which package should we pick?",packageNames:t})=>inquirer.prompt([{type:"autocomplete",name:"name",message:e,source:searchPackages(t)}]).then(({name:e})=>e),fixPackages=({plugins:e={}}={})=>({type:t,name:r,checks:n})=>{const a={fixable:[],fixes:{}};return t&&e[t]&&e[t].fix?e[t].fix({name:r,checks:n}):a};const command$4=()=>({name:"prerelease",run:prerelease,template:template$4,effect:effect}),CI=process.env.CI,kli=configure({defaultStyle:CI?{}:style}),cli=kli({commands:[command(),command$4(),command$1()]});cli.execute(process.argv.slice(2));
